package mylib;

import mylib.NumInputBox;
import java.awt.Choice;
import java.awt.Label;
import java.awt.GridBagConstraints;
import java.awt.Checkbox;
import java.applet.*;
import java.io.*;
import java.util.*;
import java.net.*;
import java.awt.Font;

/*
 *
 * NumOutputBox
 *
 */
public class NumOutputBox extends NumInputBox
{
	Label labDelim;
	Label labEOL;
	Choice chDelim;
	Choice chEOL;
//	Checkbox cbNewWindow;

	// the meanings of the choices for delimiters and end-of-line markers below

	String delims[] = {" ", "\t", ","};
	String eols[] = {"\015", "\015\012", "\012"};

	protected void commonInit (Applet a, int grid_x, int grid_y)
	{
		labDelim = new Label ("Output has what between numbers?     ");
//		labDelim.setFont (new Font("Times", Font.BOLD, 12));
		labEOL = new Label ("Output has what at end of lines?     ");
//		labEOL.setFont (new Font("Times", Font.BOLD, 12));
//		cbNewWindow = new Checkbox ("Show output in a new browser window");

		chDelim = new Choice ();
		chDelim.addItem ("Space");
		chDelim.addItem ("Tab");
		chDelim.addItem ("Comma");
		chDelim.select (1);

		chEOL = new Choice ();
		chEOL.addItem ("CR (Mac style)");
		chEOL.addItem ("CR/LF (PC style)");
		chEOL.addItem ("LF (Unix style)");
		chEOL.select (2);

		MyFuns.constrain (a, labDelim, grid_x, grid_y, 1, 1, GridBagConstraints.NONE, GridBagConstraints.EAST );
		MyFuns.constrain (a, chDelim, grid_x+1, grid_y, 1, 1, GridBagConstraints.NONE, GridBagConstraints.WEST );
		MyFuns.constrain (a, labEOL, grid_x, grid_y + 1, 1, 1, GridBagConstraints.NONE, GridBagConstraints.EAST );
		MyFuns.constrain (a, chEOL, grid_x+1, grid_y + 1, 1, 1, GridBagConstraints.NONE, GridBagConstraints.WEST );
//		MyFuns.constrain (a, cbNewWindow, grid_x, grid_y + 2, 2, 1, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST );
	}

	public NumOutputBox
			(
		
				Applet a, String t, String s, int d,
				int grid_x, int grid_y, int grid_width, int grid_height,
                int fill, int anchor, double weight_x, double weight_y,
                int top, int left, int bottom, int right
			)

	{
		super (a, t, s, d, grid_x, grid_y + 2, grid_width, grid_height, fill, anchor, weight_x, weight_y, top, left, bottom, right, false );
		commonInit (a, grid_x, grid_y);
	}

	public NumOutputBox
			(
		
				Applet a, String t, String s, int d,
				int grid_x, int grid_y, int grid_width, int grid_height,
                int fill, int anchor, double weight_x, double weight_y,
                int top, int left, int bottom, int right, boolean noDelims
			)

	{
		super (a, t, s, d, grid_x, grid_y + 2, grid_width, grid_height, fill, anchor, weight_x, weight_y, top, left, bottom, right, false );
		chDelim = null;
		chEOL = null;
		labDelim = null;
		labEOL = null;
		noDelims = noDelims;
	}

	public NumOutputBox
			(
		
				Applet a, String t, String s, int d,
				int grid_x, int grid_y, int grid_width, int grid_height,
                int fill, int anchor
			)

	{
		super (a, t, s, d, grid_x, grid_y + 2, grid_width, grid_height, fill, anchor, false);
		commonInit (a, grid_x, grid_y);
	}

	public NumOutputBox
			(
		
				Applet a, String t, String s, int d,
				int grid_x, int grid_y, int grid_width, int grid_height,
                int top, int left, int bottom, int right
			)

	{
		super (a, t, s, d, grid_x, grid_y + 2, grid_width, grid_height, top, left, bottom, right, false );
		commonInit (a, grid_x, grid_y);
	}

	public NumOutputBox
			(
		
				Applet a, String t, String s, int d,
				int grid_x, int grid_y, int grid_width, int grid_height
			)

	{
		super (a, t, s, d, grid_x, grid_y + 2, grid_width, grid_height, false);
		commonInit (a, grid_x, grid_y);
	}


	public String getDelim ()
	{
		return delims [chDelim.getSelectedIndex ()];
	}

	public String getEOL ()
	{
		return eols [chEOL.getSelectedIndex ()];
	}

/*

	public boolean useNewWindow ()
	{
		return cbNewWindow.getState ();
	}

	public void showOutput (Applet ap, String o) throws IOException, MalformedURLException
	{
		if (! useNewWindow () )
		{
			tf.setText (o);
		}
		else
		{
//			String nm = "tmp" + (new Date()).getTime ();
			String nm = "tmpfile.txt";
			File tf = new File (".", nm);
			
			PrintStream ps = new PrintStream (new FileOutputStream (tf));
			ps.println (o);
			ps.close ();
			ap.getAppletContext() .showDocument (new URL("file",null, nm), "Output");
		}
	}
*/
}

